/* Process model C form file: megaco_mg_node.pr.c */
/* Portions of this file copyright 1992-2004 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char megaco_mg_node_pr_c [] = "MIL_3_Tfile_Hdr_ 110A 30A opnet 7 4693CDC1 4693CDC1 1 hermes hlechat 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 b56 1                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#include "mg_header.h"

/* Port information */
#define XMT_OUT_STRM 0

/* State transition condition */
#define PKT_ARRIVAL    (op_intrpt_type() == OPC_INTRPT_STRM)
#define PERIODIC_INTRP (op_intrpt_type() == OPC_INTRPT_REGULAR)

#define MEGACO_PKT_ARRIVAL (MG_RxPkt == MG_MegacoPkt)
#define RTP_PKT_ARRIVAL    (MG_RxPkt == MG_RtpPkt)
#define ERR_PKT_ARRIVAL    (MG_RxPkt == MG_NoPkt)



//#define MGC0 0
//#define MG1  1
//#define MG2  2

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		DEBUG_MG                                        ;	/* Debug MG feature */
	int	                    		DEBUG_Voice                                     ;	/* Debug Voice feature */
	char	                   		USER_DestIPAddress[16]                          ;	/* User Destination IP Address */
	double	                 		USER_OffHookTime                                ;	/* User Off-Hook time in second */
	double	                 		USER_FlashHook1Time                             ;	/* User Flash-Hook 1 time in second */
	double	                 		USER_FlashHook2Time                             ;	/* User Flash-Hook 2 time in second */
	double	                 		USER_OnHookTime                                 ;	/* User On-Hook time in second */
	char	                   		MGC_IPAddress[16]                               ;	/* IP Address of the associated MGC Node */
	char	                   		MGC_IPPort[6]                                   ;	/* IP Port of the associated MGC Node */
	char	                   		MG_IPAddress[16]                                ;	/* IP Address of the MG Node */
	char	                   		MG_IPPort[6]                                    ;	/* IP Port of the MG Node */
	MG_StatusType	          		MG_Status                                       ;	/* Current MG status */
	int	                    		MG_TransactionId                                ;	/* Transaction Id for this message */
	MG_InfoType	            		MG_Info                                         ;	/* MG Node termination information */
	MG_MegacoMsgType *	     		MG_TxReqMsg                                     ;	/* MG Node transaction request message pointer */
	MG_MegacoMsgType *	     		MG_TxRlyMsg                                     ;	/* MG Node transaction reply message pointer */
	MG_MegacoMsgType *	     		MG_RxMsg                                        ;	/* MG Node receive message pointer */
	double	                 		MG_SimTime                                      ;	/* MG simulation time in second */
	int	                    		MG_DialDone                                     ;	/* MG Node dials the number or not? */
	MG_RxPktType	           		MG_RxPkt                                        ;	/* Received packet type */
	short	                  		RTP_TxVersion                                   ;	/* RTP sender version */
	int	                    		RTP_TxSequence                                  ;	/* RTP sender sequence number */
	short	                  		RTP_TxPayloadType                               ;	/* RTP sender payload type */
	double	                 		RTP_TxTimeStamp                                 ;	/* RTP sender timestamp */
	double	                 		RTP_TxSrcId                                     ;	/* RTP sender source identifier */
	RTP_MsgType *	          		RTP_TxMsg                                       ;	/* RTP sender payload */
	short	                  		RTP_RxVersion                                   ;	/* RTP receiver version */
	int	                    		RTP_RxSequence                                  ;	/* RTP receiver sequence number */
	short	                  		RTP_RxPayloadType                               ;	/* RTP receiver payload type */
	double	                 		RTP_RxTimeStamp                                 ;	/* RTP receiver timestamp */
	double	                 		RTP_RxSrcId                                     ;	/* RTP receiver source identifier */
	RTP_MsgType *	          		RTP_RxMsg                                       ;	/* RTP receiver payload */
	int	                    		RTP_RxPrevSequence                              ;	/* RTP receiver previous sequence number */
	Stathandle	             		STAT_PktSentHandle                              ;	/* Packet sent handler for storing statistics */
	Stathandle	             		STAT_PktRecvHandle                              ;	/* Packet receive handler for storing statistics */
	} megaco_mg_node_state;

#define pr_state_ptr            		((megaco_mg_node_state*) (OP_SIM_CONTEXT_PTR->_op_mod_state_ptr))
#define DEBUG_MG                		pr_state_ptr->DEBUG_MG
#define DEBUG_Voice             		pr_state_ptr->DEBUG_Voice
#define USER_DestIPAddress      		pr_state_ptr->USER_DestIPAddress
#define USER_OffHookTime        		pr_state_ptr->USER_OffHookTime
#define USER_FlashHook1Time     		pr_state_ptr->USER_FlashHook1Time
#define USER_FlashHook2Time     		pr_state_ptr->USER_FlashHook2Time
#define USER_OnHookTime         		pr_state_ptr->USER_OnHookTime
#define MGC_IPAddress           		pr_state_ptr->MGC_IPAddress
#define MGC_IPPort              		pr_state_ptr->MGC_IPPort
#define MG_IPAddress            		pr_state_ptr->MG_IPAddress
#define MG_IPPort               		pr_state_ptr->MG_IPPort
#define MG_Status               		pr_state_ptr->MG_Status
#define MG_TransactionId        		pr_state_ptr->MG_TransactionId
#define MG_Info                 		pr_state_ptr->MG_Info
#define MG_TxReqMsg             		pr_state_ptr->MG_TxReqMsg
#define MG_TxRlyMsg             		pr_state_ptr->MG_TxRlyMsg
#define MG_RxMsg                		pr_state_ptr->MG_RxMsg
#define MG_SimTime              		pr_state_ptr->MG_SimTime
#define MG_DialDone             		pr_state_ptr->MG_DialDone
#define MG_RxPkt                		pr_state_ptr->MG_RxPkt
#define RTP_TxVersion           		pr_state_ptr->RTP_TxVersion
#define RTP_TxSequence          		pr_state_ptr->RTP_TxSequence
#define RTP_TxPayloadType       		pr_state_ptr->RTP_TxPayloadType
#define RTP_TxTimeStamp         		pr_state_ptr->RTP_TxTimeStamp
#define RTP_TxSrcId             		pr_state_ptr->RTP_TxSrcId
#define RTP_TxMsg               		pr_state_ptr->RTP_TxMsg
#define RTP_RxVersion           		pr_state_ptr->RTP_RxVersion
#define RTP_RxSequence          		pr_state_ptr->RTP_RxSequence
#define RTP_RxPayloadType       		pr_state_ptr->RTP_RxPayloadType
#define RTP_RxTimeStamp         		pr_state_ptr->RTP_RxTimeStamp
#define RTP_RxSrcId             		pr_state_ptr->RTP_RxSrcId
#define RTP_RxMsg               		pr_state_ptr->RTP_RxMsg
#define RTP_RxPrevSequence      		pr_state_ptr->RTP_RxPrevSequence
#define STAT_PktSentHandle      		pr_state_ptr->STAT_PktSentHandle
#define STAT_PktRecvHandle      		pr_state_ptr->STAT_PktRecvHandle

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#  define FIN_PREAMBLE_DEC	megaco_mg_node_state *op_sv_ptr;
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_CODE	\
		op_sv_ptr = ((megaco_mg_node_state *)(sim_context_ptr->_op_mod_state_ptr));
#else
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif
static MG_CommandType 
MG_GetCommandType(char *msg)
{
	FIN (MG_Proc_get_command_type(msg))
	
	if (OPC_NIL != strstr(msg, "ServiceChange"))
	{
		FRET (MG_ServiceChangeCommand);
	}
	
	else if (OPC_NIL != strstr(msg, "Modify"))
	{
		FRET (MG_ModifyCommand);
	}
	else if (OPC_NIL != strstr(msg, "Notify"))
	{
		FRET (MG_NotifyCommand);
	}
	else if (OPC_NIL != strstr(msg, "Add"))
	{
		FRET (MG_AddCommand);
	}
	else if (OPC_NIL != strstr(msg, "Subtract"))
	{
		FRET (MG_SubtractCommand);
	}
	else if (OPC_NIL != strstr(msg, "Move"))
	{
	    FRET (MG_MoveCommand);
	}
	else if (OPC_NIL != strstr(msg, "AuditValue"))
	{
	    FRET (MG_AuditValueCommand);
	}
	else if (OPC_NIL != strstr(msg, "AuditCapabilities"))
	{
	    FRET (MG_AuditCapabilitiesCommand);
	}
	else
	{
	    op_sim_end ("Error in MG process model:",
                    "MG receives invalid message",
				    OPC_NIL, OPC_NIL);
	    FRET (MG_InvalidCommand);
	}
   
} /* MG_GetCommandType */


Boolean MG_IPString2IPInt(char *ip_string, int *ip_value)
{
    int    IP1_value;
    int    IP2_value;
    int    IP3_value;
    int    IP4_value;
    char   IP1[16];
    char   IP2[16];
    char   IP3[16];
    char   IP4[16];
    char   *start_char;
    char   *end_char;
   
    FIN(MG_IPString2IPInt(ip_string));

    /* Initialize the returned parameter */
    *ip_value = 0;
   
    memset(IP1, 0, 16);
    memset(IP2, 0, 16);
    memset(IP3, 0, 16);
    memset(IP4, 0, 16);
   
    start_char = ip_string;
    end_char = strchr(start_char, '.');
    if (end_char == OPC_NIL) 
	{
        FRET(OPC_FALSE);
    }
    strncpy(IP1, start_char, (int)(end_char - start_char));
   
    start_char = end_char + 1;
    if (*start_char == '\0') 
	{
        FRET(OPC_FALSE);
    }
    end_char = strchr(start_char, '.');
    if (end_char == OPC_NIL) 
	{
        FRET(OPC_FALSE);
    }
    strncpy(IP2, start_char, (int)(end_char - start_char));
      
    start_char = end_char + 1;
    if (*start_char == '\0') 
	{
        FRET(OPC_FALSE);
    }
    end_char = strchr(start_char, '.');
    if (end_char == OPC_NIL) 
	{
        FRET(OPC_FALSE);
    }
    strncpy(IP3, start_char, (int)(end_char - start_char));
   
    start_char = end_char + 1;
    if (*start_char == '\0')
	{
        FRET(OPC_FALSE);
    }
    strcpy(IP4, start_char);   
   
    IP1_value = atoi(IP1);
    IP2_value = atoi(IP2);
    IP3_value = atoi(IP3);
    IP4_value = atoi(IP4);
   
    *ip_value = (IP1_value & 0xFF) << 24 | (IP2_value & 0xFF) << 16 | (IP3_value & 0xFF) << 8 | (IP4_value & 0xFF);
   
    FRET(OPC_TRUE);
	
} /* MG_IPString2IPInt */


static void
MG_GetTime (char *detected_time)
{
	time_t     current_time;		  
    struct tm *local_time;
    char       year[5];
	char       month[3];
	char       day[3];
	char       second[8];

           
    FIN(getDetectedTime(detected_time));
    
    time(&current_time);
	local_time = localtime(&current_time);
	  
	sprintf(year,   "%d",   local_time->tm_year + 1900);
	sprintf(month,  "%.2d", local_time->tm_mon + 1);
    sprintf(day,    "%.2u", local_time->tm_mday);
    sprintf(second, "%u", ((local_time->tm_hour* 60 + local_time->tm_min) * 60 + local_time->tm_sec) * 10);

    strcpy(detected_time, year);
	strcat(detected_time, month);
    strcat(detected_time, day);
    strcat(detected_time, "T");
    strcat(detected_time, second);
	
    FOUT;
	
} /* MG_GetTime */


static void
MG_SendTransactionMsg()
{
    int     dest_addr;
    int     data_size_bits;
    Packet *ptr_payload_pkt;
	Packet *ptr_megaco_pkt;

    ptr_megaco_pkt = op_pk_create_fmt ("megaco_pkt_v0");
	
    /* Creates an unformatted packet with of size in bits */
   	data_size_bits  = (strlen(MG_TxReqMsg->msg) + 1) * 8;
    ptr_payload_pkt = op_pk_create(data_size_bits); 
	
    /* Sets the message in the an unformatted packet */
   	op_pk_fd_set(ptr_payload_pkt, 0, OPC_FIELD_TYPE_STRUCT, MG_TxReqMsg, data_size_bits, 
		         op_prg_mem_copy_create, op_prg_mem_free, sizeof(MG_MegacoMsgType));

	/* Load up the fields in megaco packet */
	if (OPC_FALSE == MG_IPString2IPInt(MGC_IPAddress, &dest_addr))
	{
	    op_sim_end ("Error in MG process model:",
                    "IP String to 32-bit IP Address Failed in MG_SendTransactionMsg",
				    OPC_NIL, OPC_NIL);
	}
	op_pk_nfd_set(ptr_megaco_pkt, "dest_address", dest_addr);
	op_pk_nfd_set(ptr_megaco_pkt, "data", ptr_payload_pkt);
	
  	/* Send the megaco packet message */
    op_pk_send(ptr_megaco_pkt, XMT_OUT_STRM);
	
} /* MG_SendTransactionMsg */


static void
MG_SendReplyMsg()
{
    int     dest_addr;
    int     data_size_bits;
	Packet *ptr_payload_pkt;
	Packet *ptr_megaco_pkt;

    ptr_megaco_pkt = op_pk_create_fmt ("megaco_pkt_v0");

    /* Creates an unformatted packet with of size in bits */
	data_size_bits  = (strlen(MG_TxRlyMsg->msg) + 1) * 8; 
    ptr_payload_pkt = op_pk_create(data_size_bits); 
	
	/* Sets the message in the an unformatted packet */
    op_pk_fd_set(ptr_payload_pkt, 0, OPC_FIELD_TYPE_STRUCT, MG_TxRlyMsg, data_size_bits, 
		         op_prg_mem_copy_create, op_prg_mem_free, sizeof(MG_MegacoMsgType));
	
	/* Load up the fields in megaco packet */
	if (OPC_FALSE == MG_IPString2IPInt(MGC_IPAddress, &dest_addr))
	{
	    op_sim_end ("Error in MG process model:",
                    "IP String to 32-bit IP Address Failed in MG_SendTransactionMsg",
				    OPC_NIL, OPC_NIL);
	}
	op_pk_nfd_set(ptr_megaco_pkt, "dest_address", dest_addr);
	op_pk_nfd_set(ptr_megaco_pkt, "data", ptr_payload_pkt);
	
	/* Send the megaco packet message */
    op_pk_send(ptr_megaco_pkt, XMT_OUT_STRM);
    
} /* MG_SendReplyMsg */


static void
MG_SendServiceChange()
{
	char transaction_id[10];
	char address_num[10];
	char *ptr_new_msg;
		
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Send SvcChg command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
	
	ptr_new_msg =  (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
	/* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");

	/* Transaction Id */
	strcat(ptr_new_msg, "Transaction = ");
	sprintf(transaction_id, "%d", MG_TransactionId);	   
	strcat(ptr_new_msg, transaction_id);	
	strcat(ptr_new_msg, " {\n");	  
			   
	/* Context Id */
	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, MG_Info.RootTermination.ContextId);
	strcat(ptr_new_msg, " {\n");
			   
	/* ServiceChange command for Root Termination */
	strcat(ptr_new_msg, "ServiceChange = ROOT {\n");		   	
	strcat(ptr_new_msg, "Service {\n");
		   
	strcat(ptr_new_msg, "Method=");
	strcat(ptr_new_msg, ServiceChangeMethodString[MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeMethodKey]);
	strcat(ptr_new_msg, ",\n");
		   
	strcat(ptr_new_msg, "ServiceChangeAddress=");
	sprintf(address_num, "%d", MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeAddressNum);
	strcat(ptr_new_msg, address_num);
	strcat(ptr_new_msg, ",\n");	   
	
	strcat(ptr_new_msg, "Profile=");
	strcat(ptr_new_msg, MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeProfile);
	strcat(ptr_new_msg, "\n");
			   
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");	   

	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
   	if (MG_TxReqMsg->msg != OPC_NIL)
	{
		op_prg_mem_free(MG_TxReqMsg->msg);
		MG_TxReqMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxReqMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
    strcpy (MG_TxReqMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);

	MG_SendTransactionMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Send SvcChg command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
} /* MG_SendServiceChange */

		   
static void
MG_SendNotify(MEGACO_EventType event)
{
	char transaction_id[10];
    char event_id[10];
	char detection_time[20];
	char *ptr_new_msg;

	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Send Notify command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
    	
	ptr_new_msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
	
	/* Transaction Id */
	strcat(ptr_new_msg, "Transaction = ");
	sprintf(transaction_id ,"%d", MG_TransactionId);	   
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");	  

	/* Context Id */
	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, MG_Info.UITermination.ContextId);
	strcat(ptr_new_msg, " {\n");
	
	/* Notify command for Root Termination */
	strcat(ptr_new_msg, "Notify = ui {\n");
		   
	strcat(ptr_new_msg, "ObservedEvents = ");
	sprintf(event_id ,"%d", MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[event]);
	strcat(ptr_new_msg, event_id);
	strcat(ptr_new_msg, " {\n");
	
	MG_GetTime(detection_time);
	strcat(ptr_new_msg, detection_time);
	strcat(ptr_new_msg, ":");	   
	strcat(ptr_new_msg, EventTypeString[event]);
	strcat(ptr_new_msg, "\n");
	
	if (MEGACO_KeyDigitEvent == event)
	{
	    strcat(ptr_new_msg, "{ds=\"");
		strcat(ptr_new_msg, USER_DestIPAddress);
		strcat(ptr_new_msg, "\"}\n");
	}
		   
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
	if (MG_TxReqMsg->msg != OPC_NIL)
	{
		op_prg_mem_free(MG_TxReqMsg->msg);
		MG_TxReqMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxReqMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxReqMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);
	
	MG_SendTransactionMsg();
 
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finish Execution - Send Notify command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }

} /* MG_SendNotify */


static void
MG_ReceiveServiceChange()
{
    char *start;
	char *end;	
	char transaction_id[10];
	char error_message[50];
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive SvcChg reply\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
			
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	if (MG_TransactionId == atoi(transaction_id))
	{
	    MG_TransactionId++;
		MG_Status = MG_RegisterState;
		
		if (TRUE == DEBUG_MG)
		{
		    printf("*****************************************************************\n");
   		    printf(" MG (%s) changes database:\n", MG_IPAddress);
    	    printf("*****************************************************************\n");
			printf(" MG Status = %d\n", MG_Status);
    		printf("*****************************************************************\n");
		}
    }   
	else
	{
	    sprintf(error_message, "Tx Transaction Id: %d, Rx Transaction Id: %s", MG_TransactionId, transaction_id);
	    op_sim_end ("Error in MG process model:",
                    "MG Transaction ID Verification Failed in MG_ReceiveServiceChange",
				    error_message, OPC_NIL);
	}
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Receive SvcChg reply\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
	
} /* MG_ReceiveServiceChange */

		 
static void
MG_ReceiveNotify()
{
	char *start;
	char *end;	
	char transaction_id[10];
	char error_message[50];
		
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive Notify reply\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	if (MG_TransactionId == atoi(transaction_id))
	{
	    MG_TransactionId++;		
	}	
	else
	{
	    sprintf(error_message, "Tx Transaction Id: %d, Rx Transaction Id: %s", MG_TransactionId, transaction_id);
	    op_sim_end ("Error in MG process model:",
			 	    "MG Transaction ID Verification Failed in MG_ReceiveNotify",
				    error_message, OPC_NIL);
	}
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Receive Notify reply\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
	
} /* MG_ReceiveNotify */

				 
static void
MG_ReceiveAdd()
{
    int  idx;
    char *start;
	char *end;
    char transaction_id[10];
	char context_id[10];	
	char signal[20];
	char mode[25];
	char other_mg_ip[16];
	char other_mg_port[6];
	char codec[10];
	char *ptr_new_msg;
	int  include_remote = FALSE;
	int  set_mg_status = FALSE;
		
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive Add command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
	ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
	
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "Reply = ");
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");	  
	
	/* Context Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(context_id, start+2, end-start-3);
	context_id[end-start-3] = '\0';

	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, context_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Add command for AT Termination */
	strcpy(&MG_Info.ATTermination.ContextId, context_id);
	
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
   		printf(" MG (%s) changes database:\n", MG_IPAddress);
    	printf("*****************************************************************\n");
		printf(" AT Termination:\n");
		printf("  Context Id = %s\n", MG_Info.ATTermination.ContextId);
	}
	
    start++;
	end++;		
	start = strchr(start, '=');
	end = start + 7;
	strcat(ptr_new_msg, "Add = at/hf,\n");

	if (*end != ',') 
	{    		
	    start = strchr(start, '{');						
		start++;
		start = strchr(start, '{');
		end = start;								
		end = strchr(end, '}');
		strncpy(signal, start+1, end-start-1);
		signal[end-start-1] = '\0';
		
		for (idx = 0; idx < MEGACO_NumSignal; idx++)
        {
		    if (OPC_NIL == strstr(signal, SignalTypeString[idx]))
			{
                MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 0;
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives no signal - %s\n", MG_IPAddress, SignalTypeString[idx]);
				}
			}
			else
			{
			    MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 1;
				
				if (MEGACO_CgDt == idx)
				{
				    MG_DialDone = FALSE;
				}
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives new signal - %s\n", MG_IPAddress, SignalTypeString[idx]);
				}
			}
        }
    }
					   
	if (TRUE == DEBUG_MG)
	{
		printf("*****************************************************************\n");
	}
 
	/* Add command for TR Termination */
	strcpy(&MG_Info.TRTermination.ContextId, context_id);
	
	start++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	
	strcat(ptr_new_msg, "Add = tr {\n");
	strcat(ptr_new_msg, "Media {\n");
	
	start++;
	start = strstr(start, "Mode=");
	end = strchr(end, '}');
	strncpy(mode, start, end-start);
	mode[end-start] = '\0';
	
	for (idx = 0; idx < MEGACO_NumModeKey; idx++)
	{
	    if (OPC_NIL != strstr(mode, StreamModeString[idx]))
	    {
		    MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey = idx;
			if (MEGACO_SendRecvModeKey == idx)
			{
			    set_mg_status = TRUE;
			    MG_Status = MG_ConnectState;
			}
			break;
		}
	}
	
	start = strstr(start, "Local");
	end = start;
	if (OPC_NIL != start)
	{	
	  	strcpy(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC, "IN IP4 ");
        strcat(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC, MG_IPAddress);
		strcpy(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPAddress, MG_IPAddress);
		strcpy(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM, "audio ");
		strcat(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM, RTP_PORT);
		strcat(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM, " RTP/AVP ");
		strcat(&MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM, "0");				
		MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPPortNum = atoi(RTP_PORT);
		
    	strcat(ptr_new_msg, "Local {\n");
	    strcat(ptr_new_msg, "v=0\n");
	    strcat(ptr_new_msg, "c=");
	    strcat(ptr_new_msg, &MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC);	  
	    strcat(ptr_new_msg, "\n");	   
	    strcat(ptr_new_msg, "m=");
	    strcat(ptr_new_msg, &MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM);	  
	    strcat(ptr_new_msg, "\n");	
		strcat(ptr_new_msg, "}\n");
	}

    start = strstr(start, "Remote");
	end = start;
	if (start != OPC_NIL)
	{
	    include_remote = TRUE;
	    start = strstr(start, "c=");
        end = strstr(end, "m=");
		strncpy(other_mg_ip, start+9, end-start-10);
        other_mg_ip[end-start-10]='\0';
		strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, "IN IP4 ");
		strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, other_mg_ip);
		strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress, other_mg_ip);

		start = strstr(start, "m=");
		end = strstr(end, "RTP");
		strncpy(other_mg_port, start+8, end-start-9);
		other_mg_port[end-start-9] = '\0'; 
		start = strstr(start, "AVP");
		end = strchr(end, '}');
		strncpy(codec, start+4, end-start-5); 
		codec[end-start-5] = '\0';
		strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, "audio ");
		strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, other_mg_port);
		strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, " RTP/AVP ");
		strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, codec);				
		MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum = atoi(other_mg_port);
		
		/* Initialize the RTP for the up-coming call */
		RTP_TxSequence = 0;
		RTP_RxPrevSequence = 0;
	}
		   
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
		printf(" MG (%s) changes database:\n", MG_IPAddress);
		printf("*****************************************************************\n");
		if (set_mg_status)
		{	
		    printf(" Global Information:\n");
		    printf("  MG Status = %d\n", MG_Status);
		}
		printf(" TR Termination:\n");
		printf("  Context Id = %s\n", MG_Info.TRTermination.ContextId);
		printf("  Stream Mode = %s\n", StreamModeString[MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey]);
		printf("  Local c = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC);
		printf("  Local m = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM);
		printf("  Local IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPAddress);
		printf("  Local Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPPortNum);
		if (TRUE == include_remote)
		{
		    printf("  Remote c = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC);
		    printf("  Remote m = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM);
		    printf("  Remote IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress);
		    printf("  Remote Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum);
		}
	    printf("*****************************************************************\n");
	}
		   
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");

	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
    if (MG_TxRlyMsg->msg != OPC_NIL)
	{
	    op_prg_mem_free(MG_TxRlyMsg->msg);
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxRlyMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);	
	
	MG_SendReplyMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Receive Add command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
} /* ReceiveAdd */
		   

static void
MG_ReceiveSubtract()
{
    int  idx;
    char *start;
	char *end;	
	char transaction_id[10];
	char context_id[10];	
	char termination_id[10];
	char temp_statistics[10];
	char *ptr_new_msg;
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive Subtract command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
    ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
	
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "Reply = ");
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");	  

	/* Context Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(context_id, start+2, end-start-3);
	context_id[end-start-3] = '\0';
		
	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, context_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Subtract command for AT Termination */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, ',');
	strncpy(termination_id, start, end-start);
	termination_id[end-start] = '\0';
	
	if (OPC_NIL == strstr(termination_id, "at/hf")) 
	{
	    op_sim_end ("Error in MG process model:",
                    "MG Termination ID Verification Failed in MG_ReceiveSubtract",
				    "Missing AT Termination!", OPC_NIL);
	}
	
	strcat(ptr_new_msg, "Subtract = at/hf,\n");
	
	/* Cleanup AT Termination */
	strcpy(&MG_Info.ATTermination.ContextId, "-");
	for (idx = 0; idx < MEGACO_NumSignal; idx++)
    {
        MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 0;
    }
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
	    printf(" MG (%s) changes database:\n", MG_IPAddress);
    	printf("*****************************************************************\n");
    	printf(" AT Termination:\n");
    	printf("  Context Id = %s\n", MG_Info.ATTermination.ContextId);
    	for (idx = 0; idx < MEGACO_NumSignal; idx++)
    	{
    	    printf("  Signal - %s = %d\n", SignalTypeString[idx], MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx]);
    	}

        printf("*****************************************************************\n");
    }
			
	/* Subtract command for TR Termination */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '}');
	strncpy(termination_id, start, end-start);
	termination_id[end-start] = '\0';	
	
	if (OPC_NIL == strstr(termination_id, "tr")) 
	{
	    op_sim_end ("Error in MG process model:",
                    "MG Termination ID Verification Failed in MG_ReceiveSubtract",
				    "Missing TR Termination", OPC_NIL);
	}
	
	strcat(ptr_new_msg, "Subtract = tr {\n");
	
	/* Return statistics */
	strcat(ptr_new_msg, "Statistics {\n");
	
	strcat(ptr_new_msg, "rtp/ps=");
	sprintf(temp_statistics, "%d", MG_Info.TRTermination.StatisticsDescriptor.PktSentNum);
	strcat(ptr_new_msg, temp_statistics);
	strcat(ptr_new_msg, ",\n");
	
	strcat(ptr_new_msg, "rtp/pr=");
	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum);	   
	strcat(ptr_new_msg, temp_statistics);
	strcat(ptr_new_msg, ",\n");
	
	strcat(ptr_new_msg, "rtp/pl=");
	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktLossNum);	   
    strcat(ptr_new_msg, temp_statistics);
	strcat(ptr_new_msg, ",\n");
	
	strcat(ptr_new_msg, "rtp/jit=");
	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum);	   
    strcat(ptr_new_msg, temp_statistics);
	strcat(ptr_new_msg, ",\n");
	
	strcat(ptr_new_msg, "rtp/delay=");
	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum);	   
    strcat(ptr_new_msg, temp_statistics);
	strcat(ptr_new_msg, "\n");
	
	/* Cleanup TR Termination */
	strcpy(&MG_Info.TRTermination.ContextId, "-");
	MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey = MEGACO_InactiveModeKey;
    strcpy(MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC, "");
    strcpy(MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM, "");
    strcpy(MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPAddress, "");
    MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPPortNum = 0;
    strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, "");
    strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, "");
    strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress, "");
    MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktSentNum   = 0;
    MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum  = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum   = 0;
    MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum  = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktLossNum   = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum  = 0;
	
	/* Cleanup Global data */
	MG_Status   = MG_RegisterState;
    MG_DialDone = FALSE;
	
	/* Initialize the RTP for the up-coming call */
	RTP_TxSequence = 0;
    RTP_RxPrevSequence = 0;
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
	    printf(" MG (%s) changes database:\n", MG_IPAddress);
	    printf("*****************************************************************\n");
		printf(" Global Infomration:\n");
		printf("  MG Status = %d\n", MG_Status);
	    printf(" TR Termination:\n");
	    printf("  Context Id = %s\n", MG_Info.TRTermination.ContextId);
	    printf("  Stream Mode = %s\n", StreamModeString[MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey]);
	    printf("  Local c = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC);
	    printf("  Local m = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM);
	    printf("  Local IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPAddress);
	    printf("  Local Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPPortNum);
        printf("  Remote c = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC);
        printf("  Remote m = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM);
        printf("  Remote IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress);
        printf("  Remote Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum);
    	printf("  Packet Tx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktSentNum);
    	printf("  Byte   Tx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum);
    	printf("  Packet Rx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum);
	    printf("  Byte   Rx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum);
    	printf("  Packet Loss   = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktLossNum);
    	printf("  Packet Jitter = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum);
    	printf("  Packet Delay  = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum);
        printf("*****************************************************************\n");
    }
	
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");	   
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");
	
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
	if (MG_TxRlyMsg->msg != OPC_NIL)
	{
        op_prg_mem_free(MG_TxRlyMsg->msg);
		MG_TxRlyMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxRlyMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxRlyMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);	
	
	MG_SendReplyMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finish Execution - Receive Subtract command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
} /* MG_ReceiveSubtract */
	

static void
MG_ReceiveModify()
{
    int  idx;
    char *start;
	char *end;
	char transaction_id[10];
	char context_id[10];
	char termination_id[10];
	char event_id[10];
	char event[50];
	char signal[50];
	char mode[20];	
	char other_mg_ip[16];
	char other_mg_port[6];
	char codec[10];
	int  num_of_context = 1;
	int  include_localcontrol = FALSE;
	int  include_remote = FALSE;
	char *ptr_new_msg;
			
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive Modify command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
    ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
		
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';

	strcat(ptr_new_msg, "Reply = ");
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Context Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(context_id, start+2, end-start-3);
	context_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, context_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Modify command for first Termination */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(termination_id, start+2, end-start-3);
	termination_id[end-start-3] = '\0';
	
	if (OPC_NIL != strstr(termination_id, "ui")) 
	{
	    /* Obtain the event request Id */
		start++;
		end++;
	    start = strchr(start, '=');
		end = strchr(end, '{');
	    strncpy(event_id, start+2, end-start-3);
	    event_id[end-start-3] = '\0';
		
	 	/* Obtain the event type */
		start = end;
	    end = strchr(end, '}');
	    strncpy(event, start+1, end-start-1);
	    event[end-start-1]='\0';

		if (TRUE == DEBUG_MG)
        {
            printf("*****************************************************************\n");
	        printf(" MG (%s) changes database:\n", MG_IPAddress);
    	    printf("*****************************************************************\n");
    	    printf(" UI Termination:\n");
		}
		
		for (idx = 0; idx < MEGACO_NumEvent; idx++)
        {
		    if (OPC_NIL == strstr(event, EventTypeString[idx]))
			{
                MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[idx] = 0;
			}
			else
			{
			    MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[idx] = atoi(event_id);
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives new event - %s\n", MG_IPAddress, EventTypeString[idx]);
				}
			}
        }
		
		if (TRUE == DEBUG_MG)
        {
            printf("*****************************************************************\n");
	    }
		
		/* Search for second context */
		strcat(ptr_new_msg, "Modify = ui");
		if (OPC_NIL != strstr(start, "Context"))
		{
		    num_of_context = 2;
		 	strcat(ptr_new_msg, "\n},\n");
			
			start++;
        	end++;
	        start = strchr(start, '=');
        	end = strchr(end, '{');
        	strncpy(context_id, start+2, end-start-3);
        	context_id[end-start-3] = '\0';
	
        	strcat(ptr_new_msg, "Context = ");
        	strcat(ptr_new_msg, context_id);
        	strcat(ptr_new_msg, " {\n");
		}
				   
		/* Modify command for next Termination */
		start++;
	    end++;
	    start = strchr(start, '=');
	    end = strchr(end, '{');
		
		if (OPC_NIL == start || OPC_NIL == end)
		{
		    strcat(ptr_new_msg, "\n");
		    strcpy(termination_id, "None");
		}
		else
		{
		    if (num_of_context == 1)
			{
			    strcat(ptr_new_msg, ",\n");
			}
	        strncpy(termination_id, start+2, end-start-3);
		    termination_id[end-start-3] = '\0';
		}
		
	}
					 
	if (OPC_NIL != strstr(termination_id, "at/hf"))
	{
	    start = end;
	   	start++;
		end++;
		start = strchr(start, '{');
	    end = strchr(end, '}');
		strncpy(signal, start+1, end-start-1);
		signal[end-start-1] = '\0';
		
		if (TRUE == DEBUG_MG)
        {
            printf("*****************************************************************\n");
	        printf(" MG (%s) changes database:\n", MG_IPAddress);
    	    printf("*****************************************************************\n");
    	    printf(" AT Termination:\n");
		}
		
		for (idx = 0; idx < MEGACO_NumSignal; idx++)
        {
		    if (OPC_NIL == strstr(signal, SignalTypeString[idx]))
			{
                MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 0;
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives no signal - %s\n", MG_IPAddress, SignalTypeString[idx]);
				}
			}
			else
			{
			    MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 1;
				
				if (MEGACO_CgDt == idx)
				{
				    MG_DialDone = FALSE;
				}
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives new signal - %s\n", MG_IPAddress, SignalTypeString[idx]);
				}
			}
        }
		
		if (TRUE == DEBUG_MG)
        {
    	    printf("*****************************************************************\n");
		}

		strcat(ptr_new_msg, "Modify = at/hf");
		
		/* Modify command for next Termination */
		start++;
	    end++;
	    start = strchr(start, '=');
	    end = strchr(end, '{');
		
		if (OPC_NIL == start || OPC_NIL ==end)
		{
		    strcat(ptr_new_msg, "\n");
		    strcpy(termination_id, "None");
		}
		else
		{
		    strcat(ptr_new_msg, ",\n");
	        strncpy(termination_id, start+2, end-start-3);
	        termination_id[end-start-3] = '\0';
		}
	}
					   
	if (OPC_NIL != strstr(termination_id, "tr"))
	{
	   	start++;
		end++;
				
		if (OPC_NIL != strstr(start, "Mode="))
		{
		    include_localcontrol = TRUE;
		    start = strstr(start, "Mode=");
		    end = start;
	        end = strchr(end, '}');
        	strncpy(mode, start, end-start);
	        mode[end-start] = '\0';
	
        	for (idx = 0; idx < MEGACO_NumModeKey; idx++)
	        {
	            if (OPC_NIL != strstr(mode, StreamModeString[idx]))
	            {
		            MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey = idx;
					if (MEGACO_SendRecvModeKey == idx)
					{
					    MG_Status = MG_ConnectState;
						
						/* Initialize the RTP for the up-coming call */
                    	RTP_TxSequence = 0;
                        RTP_RxPrevSequence = 0;
					}
					else
					{
					    MG_Status = MG_HoldState;
					}
			        break;
		        }
	        }
		}
	
	    if (OPC_NIL != strstr(start, "Remote"))
		{
		    include_remote = TRUE;
		    start = strstr(start, "c=");
			end = strstr(start, "m=");
			strncpy(other_mg_ip, start+9, end-start-10);
			other_mg_ip[end-start-9]='\0';
			strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, "IN IP4 ");
		    strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, other_mg_ip);
		    strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress, other_mg_ip);

		    start = strstr(start, "m=");
		    end = strstr(end, "RTP");
		    strncpy(other_mg_port, start+8, end-start-9);
	    	other_mg_port[end-start-9] = '\0'; 
	    	start = strstr(start, "AVP");
	    	end = strchr(end, '}');
	    	strncpy(codec, start+4, end-start-5); 
	    	codec[end-start-5] = '\0';
	    	strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, "audio ");
	    	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, other_mg_port);
	    	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, " RTP/AVP ");
	    	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, codec);				
	    	MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum = atoi(other_mg_port);
			
			/* Initialize the RTP for the up-coming call */
        	RTP_TxSequence = 0;
            RTP_RxPrevSequence = 0;
		}
	
	
		if (TRUE == DEBUG_MG)
        {
            printf("*****************************************************************\n");
	        printf(" MG (%s) changes database:\n", MG_IPAddress);
    	    printf("*****************************************************************\n");
			if (TRUE == include_localcontrol)
			{
			    printf(" Global Information:\n");
				printf("  MG Status = %d\n", MG_Status);
		    }
			printf(" TR Termination:\n");
			if (TRUE == include_localcontrol)
			{
			    printf("  Stream Mode = %s\n", StreamModeString[MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey]);
		    }
			if (TRUE == include_remote)
			{
			    printf("  Remote c = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC);
                printf("  Remote m = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM);
                printf("  Remote IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress);
                printf("  Remote Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum);
			}
    	    printf("*****************************************************************\n");
		}
		
		strcat(ptr_new_msg, "Modify = tr\n");
	}
						 
    strcat(ptr_new_msg, "}\n");
 	strcat(ptr_new_msg, "}\n");
	
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
	if (MG_TxRlyMsg->msg != OPC_NIL)
	{
        op_prg_mem_free(MG_TxRlyMsg->msg);
		MG_TxRlyMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxRlyMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxRlyMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);	
	
	MG_SendReplyMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finish Execution - Receive Modify command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }

} /* MG_ReceiveModify */
				 

static void
MG_ReceiveMove()
{
    int  idx;
    char *start;
	char *end;
    char transaction_id[10];
	char context_id[10];	
	char signal[20];
	char mode[20];	
	char other_mg_ip[16];
	char other_mg_port[6];
	char codec[10];
	int  include_localcontrol = FALSE;
	char *ptr_new_msg;
		
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive Move command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
	ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
	
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "Reply = ");
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");	  
	
	/* Context Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(context_id, start+2, end-start-3);
	context_id[end-start-3] = '\0';

   	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, context_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Move command for AT Termination */
	strcpy(&MG_Info.ATTermination.ContextId, context_id);
	
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
   		printf(" MG (%s) changes database:\n", MG_IPAddress);
    	printf("*****************************************************************\n");
		printf(" AT Termination:\n");
		printf("  Context Id = %s\n", MG_Info.ATTermination.ContextId);
	}
	
    start++;
	end++;		
	start = strchr(start, '=');
	end = start + 7;
	strcat(ptr_new_msg, "Move = at/hf,\n");

	if (*end != ',') 
	{    		
	    start = strchr(start, '{');						
		start++;
		start = strchr(start, '{');
		end = start;								
		end = strchr(end, '}');
		strncpy(signal, start+1, end-start-1);
		signal[end-start-1] = '\0';
		
		for (idx = 0; idx < MEGACO_NumSignal; idx++)
        {
		    if (OPC_NIL == strstr(signal, SignalTypeString[idx]))
			{
                MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 0;
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives no signal - %s\n", MG_IPAddress, SignalTypeString[idx]);
				}
			}
			else
			{
			    MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 1;
				
				if (MEGACO_CgDt == idx)
				{
				    MG_DialDone = FALSE;
				}
				
				if (TRUE == DEBUG_MG)
				{
			        printf("  MG (%s) receives new signal - %s\n", MG_IPAddress, SignalTypeString[idx]);
				}
			}
        }
    }
					   
	if (TRUE == DEBUG_MG)
	{
		printf("*****************************************************************\n");
	}
 
	/* Move command for TR Termination */
	start++;
	end++;
	strcpy(&MG_Info.TRTermination.ContextId, context_id);
	
	/* Process LocalControl descriptor, if necessary */
	if (OPC_NIL != strstr(start, "Mode="))
	{
	    include_localcontrol = TRUE;
	    start = strstr(start, "Mode=");
	    end = start;
	    end = strchr(end, '}');
       	strncpy(mode, start, end-start);
	    mode[end-start] = '\0';
	
       	for (idx = 0; idx < MEGACO_NumModeKey; idx++)
	    {
	        if (OPC_NIL != strstr(mode, StreamModeString[idx]))
	        {
	            MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey = idx;
				if (MEGACO_SendRecvModeKey == idx)
				{
				    MG_Status = MG_ConnectState;
				}
				else
				{
				    MG_Status = MG_HoldState;
				}
			    break;
		    }
	    }
    }
	
	start = strstr(start, "c=");
    end = strstr(end, "m=");
	strncpy(other_mg_ip, start+9, end-start-10);
    other_mg_ip[end-start-10]='\0';
	strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, "IN IP4 ");
	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, other_mg_ip);
	strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress, other_mg_ip);

	start = strstr(start, "m=");
	end = strstr(end, "RTP");
	strncpy(other_mg_port, start+8, end-start-9);
	other_mg_port[end-start-9] = '\0'; 
	start = strstr(start, "AVP");
	end = strchr(end, '}');
	strncpy(codec, start+4, end-start-5); 
	codec[end-start-5] = '\0';
	strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, "audio ");
	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, other_mg_port);
	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, " RTP/AVP ");
	strcat(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, codec);				
	MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum = atoi(other_mg_port);
	
	/* Initialize for up-coming call */
	MG_Info.TRTermination.StatisticsDescriptor.PktSentNum   = 0;
    MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum  = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum   = 0;
    MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum  = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktLossNum   = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum = 0;
    MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum  = 0;
	RTP_TxSequence     = 0;
    RTP_RxPrevSequence = 0;
					 
    strcat(ptr_new_msg, "Move = tr\n");
		   
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
		printf(" MG (%s) changes database:\n", MG_IPAddress);
		printf("*****************************************************************\n");
		if (TRUE == include_localcontrol)
		{
	        printf(" Global Information:\n");
			printf("  MG Status = %d\n", MG_Status);
		}
		printf(" TR Termination:\n");
		if (TRUE == include_localcontrol)
		{
		    printf("  Stream Mode = %s\n", StreamModeString[MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey]);
		}
		printf("  Context Id = %s\n", MG_Info.TRTermination.ContextId);
		printf("  Remote c = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC);
		printf("  Remote m = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM);
	    printf("  Remote IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress);
	    printf("  Remote Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum);
		printf("  Packet Tx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktSentNum);
    	printf("  Byte   Tx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum);
    	printf("  Packet Rx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum);
	    printf("  Byte   Rx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum);
    	printf("  Packet Loss   = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktLossNum);
    	printf("  Packet Jitter = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum);
    	printf("  Packet Delay  = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum);
	    printf("*****************************************************************\n");
	}
		   
	strcat(ptr_new_msg, "}\n");
	strcat(ptr_new_msg, "}\n");

	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
    if (MG_TxRlyMsg->msg != OPC_NIL)
	{
	    op_prg_mem_free(MG_TxRlyMsg->msg);
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxRlyMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);	
	
	MG_SendReplyMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Receive Move command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
		
} /* MG_ReceiveMove */
		   
static void
MG_ReceiveAuditValue()
{
    char *start;
	char *end;
    char transaction_id[10];
	char context_id[10];
	char audit_value_id[20];
	char temp_statistics[10];
	int  previous_desc = FALSE;
	char *ptr_new_msg;
	
  	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive AuditValue command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }

	ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
	
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "Reply = ");
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");	  
	
	/* Context Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(context_id, start+2, end-start-3);
	context_id[end-start-3] = '\0';

   	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, context_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Audit Value Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(audit_value_id, start+2, end-start-3);
	audit_value_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "AuditValue = ");
	strcat(ptr_new_msg, audit_value_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Return media descriptor, if necessary */
	if (OPC_NIL != strstr(start, "Media"))
	{
	    previous_desc = TRUE;
	    strcat(ptr_new_msg, "Media {\n");
		strcat(ptr_new_msg, "LocalControl {\n");
		strcat(ptr_new_msg, "Mode=");
		strcat(ptr_new_msg, StreamModeString[MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey]);
		strcat(ptr_new_msg, "\n},\n");
		
		strcat(ptr_new_msg, "Local {\n");
	    strcat(ptr_new_msg, "v=0\n");
	    strcat(ptr_new_msg, "c=");
	    strcat(ptr_new_msg, &MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC);	  
	    strcat(ptr_new_msg, "\n");	   
	    strcat(ptr_new_msg, "m=");
	    strcat(ptr_new_msg, &MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM);	  
	    strcat(ptr_new_msg, "\n");	
		strcat(ptr_new_msg, "},\n");

		strcat(ptr_new_msg, "Remote {\n");
	    strcat(ptr_new_msg, "v=0\n");
	    strcat(ptr_new_msg, "c=");
	    strcat(ptr_new_msg, &MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC);	  
	    strcat(ptr_new_msg, "\n");	   
	    strcat(ptr_new_msg, "m=");
	    strcat(ptr_new_msg, &MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM);	  
	    strcat(ptr_new_msg, "\n}\n");	
		strcat(ptr_new_msg, "}");
	}
	
	/* Return statistics descriptor, if necessary */
	if (OPC_NIL != strstr(start, "Statistics"))
	{
	    if (TRUE == previous_desc)
		{
		    strcat(ptr_new_msg, ",\n");
		}
		
		previous_desc = TRUE;
	    strcat(ptr_new_msg, "Statistics {\n");
		
    	strcat(ptr_new_msg, "rtp/ps=");
    	sprintf(temp_statistics, "%d", MG_Info.TRTermination.StatisticsDescriptor.PktSentNum);
    	strcat(ptr_new_msg, temp_statistics);
    	strcat(ptr_new_msg, ",\n");
	
    	strcat(ptr_new_msg, "rtp/pr=");
    	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum);	   
    	strcat(ptr_new_msg, temp_statistics);
    	strcat(ptr_new_msg, ",\n");
	
    	strcat(ptr_new_msg, "rtp/pl=");
    	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktLossNum);	   
        strcat(ptr_new_msg, temp_statistics);
    	strcat(ptr_new_msg, ",\n");
	
    	strcat(ptr_new_msg, "rtp/jit=");
    	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum);	   
        strcat(ptr_new_msg, temp_statistics); 
    	strcat(ptr_new_msg, ",\n");
	
    	strcat(ptr_new_msg, "rtp/delay=");
    	sprintf(temp_statistics ,"%d", MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum);	   
        strcat(ptr_new_msg, temp_statistics);
	    strcat(ptr_new_msg, "\n");
		
		strcat(ptr_new_msg, "}");
	}
	
	strcat(ptr_new_msg, "\n}");
	strcat(ptr_new_msg, "\n}");
	strcat(ptr_new_msg, "\n}\n");
		
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
    if (MG_TxRlyMsg->msg != OPC_NIL)
	{
	    op_prg_mem_free(MG_TxRlyMsg->msg);
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxRlyMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);	
	
	MG_SendReplyMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Receive AuditValue command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
  
} /* MG_ReceiveAuditValue */

				 
static void
MG_ReceiveAuditCapabilities()
{
    int  idx;
    char *start;
	char *end;
    char transaction_id[10];
	char context_id[10];
	char audit_capabilities_id[20];
	char temp_statistics[10];
	int  previous_desc = FALSE;
	char *ptr_new_msg;
	
  	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Begin Execution - Receive AuditValue command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }

	ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	
    /* Header */
	strcpy(ptr_new_msg, PROTOCOL);		
	strcat(ptr_new_msg, " [");
	strcat(ptr_new_msg, MG_IPAddress);
	strcat(ptr_new_msg, "]:");
	strcat(ptr_new_msg, MG_IPPort);
	strcat(ptr_new_msg, "\n");
	
	/* Transaction Id */
	start = strchr(MG_RxMsg->msg, '=');
	end = strchr(MG_RxMsg->msg, '{');
	strncpy(transaction_id, start+2, end-start-3);
	transaction_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "Reply = ");
	strcat(ptr_new_msg, transaction_id);
	strcat(ptr_new_msg, " {\n");	  
	
	/* Context Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(context_id, start+2, end-start-3);
	context_id[end-start-3] = '\0';

   	strcat(ptr_new_msg, "Context = ");
	strcat(ptr_new_msg, context_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Audit Capabilities Id */
	start++;
	end++;
	start = strchr(start, '=');
	end = strchr(end, '{');
	strncpy(audit_capabilities_id, start+2, end-start-3);
	audit_capabilities_id[end-start-3] = '\0';
	
	strcat(ptr_new_msg, "AuditCapabilities = ");
	strcat(ptr_new_msg, audit_capabilities_id);
	strcat(ptr_new_msg, " {\n");
	
	/* Return media descriptor, if necessary */
	if (OPC_NIL != strstr(start, "Event"))
	{
	    previous_desc = TRUE;
	    strcat(ptr_new_msg, "Event {");
		for (idx = 0; idx < MEGACO_NumEvent; idx++)
		{
		    if (0 != idx)
			{
			    strcat(ptr_new_msg, ",");
			}
    	    strcat(ptr_new_msg, EventTypeString[idx]);
		}
		strcat(ptr_new_msg, "}");
	}
	
	/* Return statistics descriptor, if necessary */
	if (OPC_NIL != strstr(start, "Signal"))
	{
	    if (TRUE == previous_desc)
		{
		    strcat(ptr_new_msg, ",\n");
		}
		
		previous_desc = TRUE;
	    strcat(ptr_new_msg, "Signal {");
		for (idx = 1; idx < MEGACO_NumSignal; idx++)
		{
		    if (1 != idx)
			{
			    strcat(ptr_new_msg, ",");
			}
    	    strcat(ptr_new_msg, SignalTypeString[idx]);
		}
		strcat(ptr_new_msg, "}");
	}
	
	strcat(ptr_new_msg, "\n}");
	strcat(ptr_new_msg, "\n}");
	strcat(ptr_new_msg, "\n}\n");
		
	if (TRUE == DEBUG_MG)
	{
	    printf("*****************************************************************\n");
	    printf(" MG (%s) sends the following message: \n", MG_IPAddress);
	    printf("*****************************************************************\n");
	    printf("%s", ptr_new_msg);
	    printf("*****************************************************************\n");
	}
	
    if (MG_TxRlyMsg->msg != OPC_NIL)
	{
	    op_prg_mem_free(MG_TxRlyMsg->msg);
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	else
	{
		MG_TxRlyMsg->msg = (char *) op_prg_mem_alloc(sizeof(char) * MEGACO_MAX_MSG_SIZE);
	}
	strcpy (MG_TxRlyMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);	
	
	MG_SendReplyMsg();
	
	if (TRUE == DEBUG_MG)
    {
        printf("*****************************************************************\n");
        printf(" MG (%s): Finsih Execution - Receive AuditValue command\n", MG_IPAddress);
        printf("*****************************************************************\n");
    }
  
} /* MG_ReceiveAuditCapabilities */
							
				 
static void
RTP_SendPacket()
{
    int     dest_addr;
	char   *ptr_new_msg;
	Packet *ptr_payload_pkt;
	Packet *ptr_megaco_pkt;

	/* Prepare for the RTP payload - simulate voice packet */
    ptr_new_msg = (char *) op_prg_mem_alloc(sizeof(char) * RTP_MAX_MSG_SIZE);
	strcpy(ptr_new_msg, MG_IPAddress);

	/* Prepare RTP packet field */
	RTP_TxSequence++;
	RTP_TxTimeStamp = op_sim_time();
	if (RTP_TxMsg->msg != OPC_NIL)
	{
		op_prg_mem_free(RTP_TxMsg->msg);
		RTP_TxMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * RTP_MAX_MSG_SIZE);
	}
	else
	{
		RTP_TxMsg->msg = (char *)op_prg_mem_alloc(sizeof(char) * RTP_MAX_MSG_SIZE);
	}
    strcpy (RTP_TxMsg->msg, ptr_new_msg);
	op_prg_mem_free(ptr_new_msg);

	/* Define the RTP packet */
	ptr_payload_pkt = op_pk_create_fmt("rtp_pkt_fmt");

	/* Load up the field in RTP packet */
	op_pk_nfd_set(ptr_payload_pkt, "version",           RTP_TxVersion);
	op_pk_nfd_set(ptr_payload_pkt, "sequence_number",   RTP_TxSequence);
	op_pk_nfd_set(ptr_payload_pkt, "payload",           RTP_TxPayloadType);
	op_pk_nfd_set(ptr_payload_pkt, "time_stamp",        RTP_TxTimeStamp);
	op_pk_nfd_set(ptr_payload_pkt, "source_identifier", RTP_TxSrcId);
   	op_pk_nfd_set(ptr_payload_pkt, "payload_data",      RTP_TxMsg,  
		          op_prg_mem_copy_create, op_prg_mem_free, sizeof(RTP_MsgType));

	/* Define the MEGACO peacket */
	ptr_megaco_pkt = op_pk_create_fmt("megaco_pkt_v0");

	/* Load up the field in MEGACO packet */
	if (OPC_FALSE == MG_IPString2IPInt(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress, &dest_addr))
	{
	    op_sim_end ("Error in MG process model:",
                    "IP String to 32-bit IP Address Failed in MG_SendTransactionMsg",
				    OPC_NIL, OPC_NIL);
	}
    op_pk_nfd_set (ptr_megaco_pkt, "dest_address", dest_addr);			
	op_pk_nfd_set (ptr_megaco_pkt, "data", ptr_payload_pkt);

	/* Send the RTP packet */
	op_pk_send (ptr_megaco_pkt, XMT_OUT_STRM);

	/* Update statistics */
	MG_Info.TRTermination.StatisticsDescriptor.PktSentNum++;
	MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum = strlen(RTP_TxMsg->msg);
	op_stat_write(STAT_PktSentHandle, MG_Info.TRTermination.StatisticsDescriptor.PktSentNum);
	
	if (TRUE == DEBUG_Voice)
	{
	    printf("*****************************************************************\n");
		printf(" MG (%s) - Send Packet\n", MG_IPAddress); 
		printf("*****************************************************************\n");
		printf("  Seq:  %d\n", RTP_TxSequence);
        printf("  Dest: %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress);
        printf("*****************************************************************\n");
	}
	
} /* RTP_SendPacket */


static void
RTP_ReceivePacket()
{
    int previous_num_packet;
    int current_num_packet;
	int previous_avg_delay;
	int previous_total_delay;
	int current_delay;
	int previous_total_jitter;
	int current_jitter;
	
	/* Initialize temp variable */
	previous_num_packet   = MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum;
	current_num_packet    = MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum + 1;
	previous_avg_delay    = MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum;
	previous_total_delay  = MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum * previous_num_packet;
	current_delay         = (op_sim_time() - RTP_RxTimeStamp) * 1000;
	previous_total_jitter = MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum * previous_num_packet;
	current_jitter        = abs(current_delay - previous_avg_delay);
	
	/* Update statistics */
	MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum   = current_num_packet;
	MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum  = strlen(RTP_RxMsg->msg);
	MG_Info.TRTermination.StatisticsDescriptor.PktLossNum  += (RTP_RxPrevSequence != (RTP_RxSequence-1));
	MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum  = (int) (previous_total_delay + current_delay) / current_num_packet;
	MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum = (int) (previous_total_jitter * current_jitter)/ current_num_packet;
	op_stat_write(STAT_PktRecvHandle, MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum);
	
	/* Update helper variable */
	RTP_RxPrevSequence = RTP_RxSequence;
	
	if (TRUE == DEBUG_Voice)
	{
	    printf("*****************************************************************\n");
		printf(" MG (%s) - Receive Packet\n", MG_IPAddress);
		printf("*****************************************************************\n");
		printf("  Seq: %d\n", RTP_RxSequence);
        printf("  Src: %s\n", RTP_RxMsg->msg);
        printf("*****************************************************************\n");
	}
	
} /* RTP_ReceivePacket */

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void megaco_mg_node (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype _op_megaco_mg_node_init (int * init_block_ptr);
	VosT_Address _op_megaco_mg_node_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void _op_megaco_mg_node_diag (OP_SIM_CONTEXT_ARG_OPT);
	void _op_megaco_mg_node_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void _op_megaco_mg_node_svar (void *, const char *, void **);


	VosT_Obtype Vos_Define_Object_Prstate (const char * _op_name, unsigned int _op_size);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
megaco_mg_node (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (megaco_mg_node ());
		{


		FSM_ENTER ("megaco_mg_node")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "megaco_mg_node [init enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mg_node [init enter execs]", state0_enter_exec)
				{
				int idx;
				
				/************************************** 
				 * Retrieve the simulation attributes *
				 **************************************/
				if (op_ima_sim_attr_exists("MG debug information") == OPC_TRUE)
				{
				   op_ima_sim_attr_get(OPC_IMA_INTEGER, "MG debug information", &DEBUG_MG);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain simulation attribute - MG debug information",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_sim_attr_exists("Voice debug information") == OPC_TRUE)
				{
				   op_ima_sim_attr_get(OPC_IMA_INTEGER, "Voice debug information", &DEBUG_Voice);
				}	
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain simulation attribute - Voice debug information",
				               OPC_NIL, OPC_NIL);
				}
				
				/********************************** 
				 * Retrieve the object attributes *
				 **********************************/
				if (op_ima_obj_attr_exists(op_id_self(), "MGC IP Address") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "MGC IP Address", MGC_IPAddress);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - MGC IP Address",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "MGC IP Port") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "MGC IP Port", MGC_IPPort);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - MGC IP Port",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "MG IP Address") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "MG IP Address", MG_IPAddress);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - MG IP Address",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "MG IP Port") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "MG IP Port", MG_IPPort);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - MG IP Port",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "MG Transaction ID") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "MG Transaction ID", &MG_TransactionId);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - MG Transaction ID",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "User Dial-Up IP Address") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "User Dial-Up IP Address", USER_DestIPAddress);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - User Off-Hook Time (sec)",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "User Off-Hook Time (sec)") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "User Off-Hook Time (sec)", &USER_OffHookTime);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - User Off-Hook Time (sec)",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "User Flash-Hook 1 Time (sec)") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "User Flash-Hook 1 Time (sec)", &USER_FlashHook1Time);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - User Flash-Hook 1 Time (sec)",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "User Flash-Hook 2 Time (sec)") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "User Flash-Hook 2 Time (sec)", &USER_FlashHook2Time);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - User Flash-Hook 2 Time (sec)",
				               OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "User On-Hook Time (sec)") == OPC_TRUE)
				{
				    op_ima_obj_attr_get(op_id_self(), "User On-Hook Time (sec)", &USER_OnHookTime);
				}
				else
				{
				   op_sim_end ("Error in MG process model:",
					           "Can't obtain object attribute - User On-Hook Time (sec)",
				               OPC_NIL, OPC_NIL);
				}
				
				/*******************************  
				 * Initialize the MG Node data *
				 *******************************/
				
				if (TRUE == DEBUG_MG)
				{
				    printf("*****************************************************************\n");
				    printf(" MG (%s): Begin Execution - Enter Init State\n", MG_IPAddress);
					printf("*****************************************************************\n");
				
				}
				
				/* MG global information */
				MG_Status = MG_RestartState;
				MG_TxReqMsg = (MG_MegacoMsgType *) op_prg_mem_alloc(sizeof(MG_MegacoMsgType));
				MG_TxRlyMsg = (MG_MegacoMsgType *) op_prg_mem_alloc(sizeof(MG_MegacoMsgType));
				MG_SimTime = 0;
				MG_DialDone = FALSE;
				MG_RxPkt = MG_NoPkt;
				
				/* MG Root termination information */
				strcpy(MG_Info.RootTermination.ContextId, "-");
				MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeMethodKey = MEGACO_RestartMethodKey;
				MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeAddressNum = atoi(MG_IPPort);
				strcpy(MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeProfile, PROFILE);
				
				/* MG Audio Transducer termination information */
				strcpy(MG_Info.ATTermination.ContextId, "-");
				for (idx = 0; idx < MEGACO_NumSignal; idx++)
				{
				   MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx] = 0;
				}
				
				/* MG User Interface termination information */
				strcpy(MG_Info.UITermination.ContextId, "-");
				for (idx = 0; idx < MEGACO_NumEvent; idx++)
				{
				   MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[idx] = 0;
				}
				
				/* MG TR termination information */
				strcpy(MG_Info.TRTermination.ContextId, "-");
				MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey = MEGACO_InactiveModeKey;
				strcpy(MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC, "");
				strcpy(MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM, "");
				strcpy(MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPAddress, "");
				MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPPortNum = 0;
				strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC, "");
				strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM, "");
				strcpy(MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress, "");
				MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum = 0;
				MG_Info.TRTermination.StatisticsDescriptor.PktSentNum   = 0;
				MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum  = 0;
				MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum   = 0;
				MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum  = 0;
				MG_Info.TRTermination.StatisticsDescriptor.PktLossNum   = 0;
				MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum = 0;
				MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum  = 0;
				
				if (TRUE == DEBUG_MG)
				{
				    printf("*****************************************************************\n");
					printf(" MG (%s) initializes database:\n", MG_IPAddress);
					printf("*****************************************************************\n");
					printf(" Global Information:\n");
					printf("  Debug MG = %d\n", DEBUG_MG);
					printf("  Debug Voice = %d\n", DEBUG_Voice);
					printf("  MGC IP Address = %s\n", MGC_IPAddress);
					printf("  MGC IP Port    = %s\n", MGC_IPPort);
					printf("  MG  IP Address = %s\n", MG_IPAddress);
					printf("  MG  IP Port    = %s\n", MG_IPPort);
					printf("  MG  Transaction Id = %d\n", MG_TransactionId);
					printf("  MG  Status = %d\n", MG_Status);
					printf("  USER Destination IP Address  = %s\n", USER_DestIPAddress);
					printf("  USER Off-Hook Time (sec)     = %d\n", USER_OffHookTime);
					printf("  USER Flash-Hook 1 Time (sec) = %d\n", USER_FlashHook1Time);
					printf("  USER Flash-Hook 2 Time (sec) = %d\n", USER_FlashHook2Time);
					printf("  USER On-Hook Time (sec)      = %d\n", USER_OnHookTime);
					printf(" Root Termination:\n");
					printf("  Context Id = %s\n", MG_Info.RootTermination.ContextId);
					printf("  Method = %s\n", ServiceChangeMethodString[MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeMethodKey]);
					printf("  Port Address = %d\n", MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeAddressNum);
					printf("  Profile = %s\n", MG_Info.RootTermination.ServiceChangeDescriptor.ServiceChangeProfile);
					printf(" AT Termination:\n");
					printf("  Context Id = %s\n", MG_Info.ATTermination.ContextId);
					for (idx = 0; idx < MEGACO_NumSignal; idx++)
					{
					    printf("  Signal - %s = %d\n", SignalTypeString[idx], MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[idx]);
					}
					printf(" UI Termination:\n");
					printf("  Context Id = %s\n", MG_Info.UITermination.ContextId);
					for (idx = 0; idx < MEGACO_NumEvent; idx++)
					{
					    printf("  Event - %s = %d\n", EventTypeString[idx], MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[idx]);
					}
					printf(" TR Termination:\n");
					printf("  Context Id = %s\n", MG_Info.TRTermination.ContextId);
					printf("  Stream Mode = %s\n", StreamModeString[MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey]);
					printf("  Local c = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalC);
					printf("  Local m = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalM);
					printf("  Local IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPAddress);
					printf("  Local Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.LocalDesc.LocalIPPortNum);
				    printf("  Remote c = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteC);
				    printf("  Remote m = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteM);
				    printf("  Remote IP Address  = %s\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPAddress);
				    printf("  Remote Port Number = %d\n", MG_Info.TRTermination.MediaDescriptor.RemoteDesc.RemoteIPPortNum);
					printf("  Packet Tx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktSentNum);
					printf("  Byte   Tx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.ByteSentNum);
					printf("  Packet Rx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktRecvNum);
					printf("  Byte   Rx = %d\n", MG_Info.TRTermination.StatisticsDescriptor.ByteRecvNum);
					printf("  Packet Loss   = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktLossNum);
					printf("  Packet Jitter = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktJitterNum);
					printf("  Packet Delay  = %d\n", MG_Info.TRTermination.StatisticsDescriptor.PktDelayNum);
				    printf("*****************************************************************\n");
				}
				
				/* RTP Protocol Information */
				RTP_TxVersion      = 1;
				RTP_TxSequence     = 0;
				RTP_TxPayloadType  = 8;
				RTP_TxTimeStamp    = op_sim_time();
				RTP_TxSrcId        = atoi(RTP_PORT);
				RTP_TxMsg          = (RTP_MsgType *) op_prg_mem_alloc(sizeof(RTP_MsgType));
				RTP_RxPrevSequence = 0;
				
				/* Statistics handler */
				STAT_PktSentHandle = op_stat_reg("RTP Traffic Packet Tx",OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				STAT_PktRecvHandle = op_stat_reg("RTP Traffic Packet Rx",OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				if (TRUE == DEBUG_MG)
				{
				    printf("*****************************************************************\n");
				    printf(" MG (%s): Finish Execution - Enter Init State\n", MG_IPAddress);
					printf("*****************************************************************\n");
				}
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "megaco_mg_node [init exit execs]")


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle", "megaco_mg_node [init -> idle : default / ]")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "idle", state1_enter_exec, "megaco_mg_node [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mg_node [idle enter execs]", state1_enter_exec)
				{
				MG_RxPkt = MG_NoPkt;
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"megaco_mg_node")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "megaco_mg_node [idle exit execs]")


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("megaco_mg_node [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PKT_ARRIVAL)
			FSM_TEST_COND (PERIODIC_INTRP)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 4, state4_enter_exec, ;, "PKT_ARRIVAL", "", "idle", "MSG_Pr", "megaco_mg_node [idle -> MSG_Pr : PKT_ARRIVAL / ]")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PERIODIC_INTRP", "", "idle", "USR_Pr", "megaco_mg_node [idle -> USR_Pr : PERIODIC_INTRP / ]")
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;, "default", "", "idle", "idle", "megaco_mg_node [idle -> idle : default / ]")
				}
				/*---------------------------------------------------------*/



			/** state (MG_Pr) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "MG_Pr", state2_enter_exec, "megaco_mg_node [MG_Pr enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mg_node [MG_Pr enter execs]", state2_enter_exec)
				{
				MG_CommandType command_type;
				
				command_type = MG_GetCommandType(MG_RxMsg->msg);
					
				switch (command_type)
				{
				    case MG_ServiceChangeCommand:
					
					    MG_ReceiveServiceChange();
						break;
							
					case MG_ModifyCommand:
					
					    MG_ReceiveModify();
						break;
					
					case MG_NotifyCommand:
				
					    MG_ReceiveNotify();
						break;
					
					case MG_AddCommand:
					
					    MG_ReceiveAdd();
						break;
					
					case MG_SubtractCommand:
					
					    MG_ReceiveSubtract();
						break;
					
					case MG_MoveCommand:
					
					     MG_ReceiveMove();
					    break;
					
					case MG_AuditValueCommand:
					
					    MG_ReceiveAuditValue();
					    break;
					
					case MG_AuditCapabilitiesCommand:
					
					    MG_ReceiveAuditCapabilities();
						break;
					
				    default:
				
						op_sim_end ("Error in MG_Pr module:", 
							        "Receiving unknown Megaco command!", 
									OPC_NIL, OPC_NIL);
						break;
				}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (MG_Pr) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "MG_Pr", "megaco_mg_node [MG_Pr exit execs]")


			/** state (MG_Pr) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "MG_Pr", "idle", "megaco_mg_node [MG_Pr -> idle : default / ]")
				/*---------------------------------------------------------*/



			/** state (USR_Pr) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "USR_Pr", state3_enter_exec, "megaco_mg_node [USR_Pr enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mg_node [USR_Pr enter execs]", state3_enter_exec)
				{
				if (MG_NoPkt == MG_RxPkt)
				{
				    /*********************
					 * Regular interrupt *
					 *********************/
				
				    /* Update the timer for regular interrupt */
				    if (++MG_SimTime == 0)
					{
					    op_sim_end ("Error in MG process model:",
				                    "Simulation is too long!",
								    OPC_NIL, OPC_NIL);
					}
					
					/* Register the MG */
				    if (MG_RestartState == MG_Status)
				    {
				        MG_Status = MG_RegisteringState;
				        MG_SendServiceChange();
				    }
				
					/* Dial the number upon receiving the dial tone */
					if (0 != MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[MEGACO_CgDt] &&
						0 != MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[MEGACO_KeyDigitEvent] &&
						FALSE == MG_DialDone)
					{
					    MG_DialDone = TRUE;
						MG_SendNotify(MEGACO_KeyDigitEvent);
					}
					
					/* Send voice packet during call conversation */
					if (MEGACO_SendRecvModeKey == MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey &&
						0 == MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[MEGACO_CgDt] &&
						0 == MG_Info.ATTermination.SignalDescriptor.SignalTypeRequestIdNum[MEGACO_CgRt])
					{
					    RTP_SendPacket();
					}
					
				    /* Pick-up the phone receiver (Off-Hook) */
				    if (MG_SimTime == USER_OffHookTime)
				    {
				        if (0 != MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[MEGACO_KeyKdEvent])
					    {
					        MG_SendNotify(MEGACO_KeyKdEvent);
					    }
				        else
				    	{
					        op_sim_end ("Error in MG process model:",
				                        "Invalid user-initiated operation - Off-Hook",
							    	    OPC_NIL, OPC_NIL);
					    }
				    }
				
				    /* Switch for the first call-waiting (Flash-Hook) */
				    if (MG_SimTime == USER_FlashHook1Time)
				    {
				        if (0 != MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[MEGACO_KeyFlashEvent])
				    	{
					        MG_SendNotify(MEGACO_KeyFlashEvent);
					    }
				        else
				    	{
					        op_sim_end ("Error in MG process model:",
				                        "Invalid user-initiated operation - Flash-Hook 1",
							    	    OPC_NIL, OPC_NIL);
					    }
				    }
				
				    /* Switch for the second call-waiting (Flash-Hook) */
				    if (MG_SimTime == USER_FlashHook2Time)
				    {
				        if (0 != MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[MEGACO_KeyFlashEvent])
					    {
					        MG_SendNotify(MEGACO_KeyFlashEvent);
					    }
				        else
				    	{
					        op_sim_end ("Error in MG process model:",
				                        "Invalid user-initiated operation - Flash-Hook 2",
							    	    OPC_NIL, OPC_NIL);
				    	}
				    }
				
				    /* Release the call (On-Hook) */
				    if (MG_SimTime == USER_OnHookTime)
				    {
				        if (0 != MG_Info.UITermination.EventDescriptor.EventTypeRequestIdNum[MEGACO_KeyKuEvent])
					    {
					        MG_SendNotify(MEGACO_KeyKuEvent);
					    }
				        else
					    {
					        op_sim_end ("Error in MG process model:",
				                        "Invalid user-initiated operation - On-Hook",
								        OPC_NIL, OPC_NIL);
					    }
				    }
				}
				else
				{
				    /**********************
					 * RTP Packet arrival *
					 **********************/
				    if (MEGACO_SendRecvModeKey == MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey ||
						MEGACO_RecvOnlyModeKey == MG_Info.TRTermination.MediaDescriptor.LocalControlDesc.StreamModeKey)
					{
				        RTP_ReceivePacket();
					}
				}
				
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (USR_Pr) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "USR_Pr", "megaco_mg_node [USR_Pr exit execs]")


			/** state (USR_Pr) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "USR_Pr", "idle", "megaco_mg_node [USR_Pr -> idle : default / ]")
				/*---------------------------------------------------------*/



			/** state (MSG_Pr) enter executives **/
			FSM_STATE_ENTER_FORCED (4, "MSG_Pr", state4_enter_exec, "megaco_mg_node [MSG_Pr enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mg_node [MSG_Pr enter execs]", state4_enter_exec)
				{
				char    format[15];
				Packet *ptr_megaco_pkt;
				Packet *ptr_payload_pkt;
				
				/* Initialize the received packet type */
				MG_RxPkt = MG_NoPkt;
				
				/* Get the pointer of incoming packet */
				ptr_megaco_pkt = op_pk_get (op_intrpt_strm ());
				
				
				//get the data from the incoming packet which is also a packet
				op_pk_nfd_get(ptr_megaco_pkt, "data", &ptr_payload_pkt);
				op_pk_format(ptr_payload_pkt, format);
				
				if (strcmp(format, "NONE") == 0)
				{
				    /* MEGACO Message */
				    MG_RxPkt = MG_MegacoPkt;
					
					/* Store the MEGACO Message */
					op_pk_fd_get(ptr_payload_pkt, 0, &MG_RxMsg);
						
				    /* Destroy Packets */
					op_pk_destroy(ptr_megaco_pkt);
					op_pk_destroy(ptr_payload_pkt);
				
				}
				else if (strcmp(format, "rtp_pkt_fmt") == 0)
				{
				    /* RTP Packet */
				    MG_RxPkt = MG_RtpPkt;
					
					/* Store the RTP Message */
					op_pk_nfd_get(ptr_payload_pkt, "version",           &RTP_RxVersion);
					op_pk_nfd_get(ptr_payload_pkt, "sequence_number",   &RTP_RxSequence);
					op_pk_nfd_get(ptr_payload_pkt, "payload",           &RTP_RxPayloadType);
					op_pk_nfd_get(ptr_payload_pkt, "time_stamp",        &RTP_RxTimeStamp);
					op_pk_nfd_get(ptr_payload_pkt, "source_identifier", &RTP_RxSrcId);
					op_pk_nfd_get(ptr_payload_pkt, "payload_data",      &RTP_RxMsg);
					
					/* Destroy Packets */
					op_pk_destroy(ptr_megaco_pkt);
					op_pk_destroy(ptr_payload_pkt);
					
				}
				else
				{
					/* No Packets */
				    MG_RxPkt = MG_NoPkt;
				
					/* Destroy Packets */
					op_pk_destroy(ptr_megaco_pkt);
					op_pk_destroy(ptr_payload_pkt);
				
				}
				
				}
				FSM_PROFILE_SECTION_OUT (state4_enter_exec)

			/** state (MSG_Pr) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "MSG_Pr", "megaco_mg_node [MSG_Pr exit execs]")


			/** state (MSG_Pr) transition processing **/
			FSM_PROFILE_SECTION_IN ("megaco_mg_node [MSG_Pr trans conditions]", state4_trans_conds)
			FSM_INIT_COND (MEGACO_PKT_ARRIVAL)
			FSM_TEST_COND (RTP_PKT_ARRIVAL)
			FSM_TEST_COND (ERR_PKT_ARRIVAL)
			FSM_TEST_LOGIC ("MSG_Pr")
			FSM_PROFILE_SECTION_OUT (state4_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "MEGACO_PKT_ARRIVAL", "", "MSG_Pr", "MG_Pr", "megaco_mg_node [MSG_Pr -> MG_Pr : MEGACO_PKT_ARRIVAL / ]")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "RTP_PKT_ARRIVAL", "", "MSG_Pr", "USR_Pr", "megaco_mg_node [MSG_Pr -> USR_Pr : RTP_PKT_ARRIVAL / ]")
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;, "ERR_PKT_ARRIVAL", "", "MSG_Pr", "idle", "megaco_mg_node [MSG_Pr -> idle : ERR_PKT_ARRIVAL / ]")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"megaco_mg_node")
		}
	}




void
_op_megaco_mg_node_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
_op_megaco_mg_node_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (_op_megaco_mg_node_terminate ())


	/* No Termination Block */

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in _op_megaco_mg_node_svar function. */
#undef DEBUG_MG
#undef DEBUG_Voice
#undef USER_DestIPAddress
#undef USER_OffHookTime
#undef USER_FlashHook1Time
#undef USER_FlashHook2Time
#undef USER_OnHookTime
#undef MGC_IPAddress
#undef MGC_IPPort
#undef MG_IPAddress
#undef MG_IPPort
#undef MG_Status
#undef MG_TransactionId
#undef MG_Info
#undef MG_TxReqMsg
#undef MG_TxRlyMsg
#undef MG_RxMsg
#undef MG_SimTime
#undef MG_DialDone
#undef MG_RxPkt
#undef RTP_TxVersion
#undef RTP_TxSequence
#undef RTP_TxPayloadType
#undef RTP_TxTimeStamp
#undef RTP_TxSrcId
#undef RTP_TxMsg
#undef RTP_RxVersion
#undef RTP_RxSequence
#undef RTP_RxPayloadType
#undef RTP_RxTimeStamp
#undef RTP_RxSrcId
#undef RTP_RxMsg
#undef RTP_RxPrevSequence
#undef STAT_PktSentHandle
#undef STAT_PktRecvHandle

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
_op_megaco_mg_node_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (_op_megaco_mg_node_init (init_block_ptr))

	obtype = Vos_Define_Object_Prstate ("proc state vars (megaco_mg_node)",
		sizeof (megaco_mg_node_state));
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
_op_megaco_mg_node_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	megaco_mg_node_state * ptr;
	FIN_MT (_op_megaco_mg_node_alloc (obtype))

	ptr = (megaco_mg_node_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		{
		ptr->_op_current_block = init_block;
#if defined (OPD_ALLOW_ODB)
		ptr->_op_current_state = "megaco_mg_node [init enter execs]";
#endif
		}
	FRET ((VosT_Address)ptr)
	}



void
_op_megaco_mg_node_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	megaco_mg_node_state		*prs_ptr;

	FIN_MT (_op_megaco_mg_node_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (megaco_mg_node_state *)gen_ptr;

	if (strcmp ("DEBUG_MG" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->DEBUG_MG);
		FOUT
		}
	if (strcmp ("DEBUG_Voice" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->DEBUG_Voice);
		FOUT
		}
	if (strcmp ("USER_DestIPAddress" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->USER_DestIPAddress);
		FOUT
		}
	if (strcmp ("USER_OffHookTime" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->USER_OffHookTime);
		FOUT
		}
	if (strcmp ("USER_FlashHook1Time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->USER_FlashHook1Time);
		FOUT
		}
	if (strcmp ("USER_FlashHook2Time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->USER_FlashHook2Time);
		FOUT
		}
	if (strcmp ("USER_OnHookTime" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->USER_OnHookTime);
		FOUT
		}
	if (strcmp ("MGC_IPAddress" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->MGC_IPAddress);
		FOUT
		}
	if (strcmp ("MGC_IPPort" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->MGC_IPPort);
		FOUT
		}
	if (strcmp ("MG_IPAddress" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->MG_IPAddress);
		FOUT
		}
	if (strcmp ("MG_IPPort" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->MG_IPPort);
		FOUT
		}
	if (strcmp ("MG_Status" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_Status);
		FOUT
		}
	if (strcmp ("MG_TransactionId" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_TransactionId);
		FOUT
		}
	if (strcmp ("MG_Info" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_Info);
		FOUT
		}
	if (strcmp ("MG_TxReqMsg" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_TxReqMsg);
		FOUT
		}
	if (strcmp ("MG_TxRlyMsg" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_TxRlyMsg);
		FOUT
		}
	if (strcmp ("MG_RxMsg" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_RxMsg);
		FOUT
		}
	if (strcmp ("MG_SimTime" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_SimTime);
		FOUT
		}
	if (strcmp ("MG_DialDone" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_DialDone);
		FOUT
		}
	if (strcmp ("MG_RxPkt" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->MG_RxPkt);
		FOUT
		}
	if (strcmp ("RTP_TxVersion" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_TxVersion);
		FOUT
		}
	if (strcmp ("RTP_TxSequence" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_TxSequence);
		FOUT
		}
	if (strcmp ("RTP_TxPayloadType" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_TxPayloadType);
		FOUT
		}
	if (strcmp ("RTP_TxTimeStamp" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_TxTimeStamp);
		FOUT
		}
	if (strcmp ("RTP_TxSrcId" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_TxSrcId);
		FOUT
		}
	if (strcmp ("RTP_TxMsg" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_TxMsg);
		FOUT
		}
	if (strcmp ("RTP_RxVersion" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxVersion);
		FOUT
		}
	if (strcmp ("RTP_RxSequence" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxSequence);
		FOUT
		}
	if (strcmp ("RTP_RxPayloadType" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxPayloadType);
		FOUT
		}
	if (strcmp ("RTP_RxTimeStamp" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxTimeStamp);
		FOUT
		}
	if (strcmp ("RTP_RxSrcId" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxSrcId);
		FOUT
		}
	if (strcmp ("RTP_RxMsg" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxMsg);
		FOUT
		}
	if (strcmp ("RTP_RxPrevSequence" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->RTP_RxPrevSequence);
		FOUT
		}
	if (strcmp ("STAT_PktSentHandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->STAT_PktSentHandle);
		FOUT
		}
	if (strcmp ("STAT_PktRecvHandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->STAT_PktRecvHandle);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

